//+------------------------------------------------------------------+
//|                                        Top Indicators Collection |
//|                                 https://www.forex-indicators.org |
//+------------------------------------------------------------------+

#property copyright   "www.forex-indicators.org"
#property link        "https://www.forex-indicators.org"
#property description "If this indicator does not work, please contact us at: bestindicators@proton.me"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_plots   2
#property indicator_color1  clrRed, clrDeepSkyBlue, clrYellow, clrLime, clrWhite, clrMagenta
#property indicator_type1   DRAW_COLOR_HISTOGRAM
#property indicator_width1  2
#property indicator_color2  clrMaroon
#property indicator_label2  "Average"
#property indicator_type2   DRAW_LINE
#property indicator_width2  2

input int     NumberOfBars = 500;
input string  Note = "0 means Display all bars";
input int     MAPeriod = 100;
input int     LookBack = 20;

double Histogram[];
double HistogramColor[];
double Average[];

int LastCounted = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
{
	IndicatorSetString(INDICATOR_SHORTNAME, "BV(" + IntegerToString(MAPeriod) + ", " + IntegerToString(LookBack) + ")");
	
	SetIndexBuffer(0, Histogram, INDICATOR_DATA);
	SetIndexBuffer(1, HistogramColor, INDICATOR_COLOR_INDEX);
	SetIndexBuffer(2, Average, INDICATOR_DATA);
}

//+------------------------------------------------------------------+
//| CDRW                                                             |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &Time[],
                const double &open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &Tickvolume[],
                const long &volume[],
                const int &spread[])
{
   double VolLowest, Range, Value2, Value3, HiValue2, HiValue3, LoValue3, tempv2, tempv3, tempv;
   int limit, n ,i;

   int minbars = MathMax(20, MathMax(MAPeriod, LookBack));

   limit = LastCounted - 1;
   if (NumberOfBars > 0) 
      if (rates_total - limit > NumberOfBars) limit = rates_total - NumberOfBars;

   if (limit < minbars) limit = minbars;
      
   for (i = rates_total - 1; i >= limit; i--)   
   {
      Histogram[i] = Tickvolume[i];
      HistogramColor[i] = 1;
      
      Value2 = 0; Value3 = 0; HiValue2 = 0; HiValue3 = 0; LoValue3 = DBL_MAX; tempv2 = 0; tempv3 = 0; tempv = 0;
      
      
      VolLowest = Tickvolume[ArrayMinimum(Tickvolume, i - 19, 20)];
      if (Tickvolume[i] == VolLowest)
         HistogramColor[i] = 2;
            
      Range = (High[i] - Low[i]);
      Value2 = Tickvolume[i] * Range;
      
      if (Range != 0) Value3 = Tickvolume[i] / Range;
         
      for (n = i; n > i - MAPeriod; n--)
      {
         tempv += Tickvolume[n];
      } 
      
      Average[i] = NormalizeDouble(tempv / MAPeriod, 0);
      
      for (n = i; n > i - LookBack; n--)
      {
         tempv2 = Tickvolume[n] * (High[n] - Low[n]); 
         if (tempv2 > HiValue2) HiValue2 = tempv2;
              
         if (Tickvolume[n] * (High[n] - Low[n]) != 0)
         {           
            tempv3 = Tickvolume[n] / (High[n] - Low[n]);
            if (tempv3 > HiValue3) HiValue3 = tempv3; 
            if (tempv3 < LoValue3) LoValue3 = tempv3;
         } 
      }
                                   
      if ((Value2 == HiValue2) && (Close[i] > (High[i] + Low[i]) / 2))
         HistogramColor[i] = 0;
        
      if (Value3 == HiValue3)
         HistogramColor[i] = 3;
      
      if ((Value2 == HiValue2) && (Value3 == HiValue3))
         HistogramColor[i] = 5;
      
      if ((Value2 == HiValue2)  && (Close[i] <= (High[i] + Low[i]) / 2))
         HistogramColor[i] = 4;
   }
      
   LastCounted = rates_total;
   return(rates_total);
}
//+------------------------------------------------------------------+
         